GNU Linux-libre 4.19.263-gnu1
[releases.git] / tools / perf / tests / shell / record+probe_libc_inet_pton.sh
1 # probe libc's inet_pton & backtrace it with ping
2
3 # Installs a probe on libc's inet_pton function, that will use uprobes,
4 # then use 'perf trace' on a ping to localhost asking for just one packet
5 # with the a backtrace 3 levels deep, check that it is what we expect.
6 # This needs no debuginfo package, all is done using the libc ELF symtab
7 # and the CFI info in the binaries.
8
9 # Arnaldo Carvalho de Melo <acme@kernel.org>, 2017
10
11 . $(dirname $0)/lib/probe.sh
12
13 libc=$(grep -w libc /proc/self/maps | head -1 | sed -r 's/.*[[:space:]](\/.*)/\1/g')
14 nm -Dg $libc 2>/dev/null | fgrep -q inet_pton || exit 254
15
16 event_pattern='probe_libc:inet_pton(\_[[:digit:]]+)?'
17
18 add_libc_inet_pton_event() {
19
20         event_name=$(perf probe -f -x $libc -a inet_pton 2>&1 | tail -n +2 | head -n -5 | \
21                         grep -P -o "$event_pattern(?=[[:space:]]\(on inet_pton in $libc\))")
22
23         if [ $? -ne 0 -o -z "$event_name" ] ; then
24                 printf "FAIL: could not add event\n"
25                 return 1
26         fi
27 }
28
29 trace_libc_inet_pton_backtrace() {
30
31         expected=`mktemp -u /tmp/expected.XXX`
32
33         echo "ping[][0-9 \.:]+$event_name: \([[:xdigit:]]+\)" > $expected
34         echo ".*inet_pton\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
35         case "$(uname -m)" in
36         s390x)
37                 eventattr='call-graph=dwarf,max-stack=4'
38                 echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
39                 echo "(__GI_)?getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
40                 echo "main\+0x[[:xdigit:]]+[[:space:]]\(.*/bin/ping.*\)$" >> $expected
41                 ;;
42         ppc64|ppc64le)
43                 eventattr='max-stack=4'
44                 echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
45                 echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
46                 echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
47                 ;;
48         *)
49                 eventattr='max-stack=3'
50                 echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
51                 echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
52                 ;;
53         esac
54
55         perf_data=`mktemp -u /tmp/perf.data.XXX`
56         perf_script=`mktemp -u /tmp/perf.script.XXX`
57         perf record -e $event_name/$eventattr/ -o $perf_data ping -6 -c 1 ::1 > /dev/null 2>&1
58         perf script -i $perf_data > $perf_script
59
60         exec 3<$perf_script
61         exec 4<$expected
62         while read line <&3 && read -r pattern <&4; do
63                 [ -z "$pattern" ] && break
64                 echo $line
65                 echo "$line" | egrep -q "$pattern"
66                 if [ $? -ne 0 ] ; then
67                         printf "FAIL: expected backtrace entry \"%s\" got \"%s\"\n" "$pattern" "$line"
68                         return 1
69                 fi
70         done
71
72         # If any statements are executed from this point onwards,
73         # the exit code of the last among these will be reflected
74         # in err below. If the exit code is 0, the test will pass
75         # even if the perf script output does not match.
76 }
77
78 delete_libc_inet_pton_event() {
79
80         if [ -n "$event_name" ] ; then
81                 perf probe -q -d $event_name
82         fi
83 }
84
85 # Check for IPv6 interface existence
86 ip a sh lo | fgrep -q inet6 || exit 2
87
88 skip_if_no_perf_probe && \
89 add_libc_inet_pton_event && \
90 trace_libc_inet_pton_backtrace
91 err=$?
92 rm -f ${perf_data} ${perf_script} ${expected}
93 delete_libc_inet_pton_event
94 exit $err